#!/usr/local/bin/pgoblin -f
  Copyright (C)2019 @BABOLO http://www.babolo.ru/
  PKG = mini-cipa-dripa
  All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions
  are met:
  1. Redistributions of source code must retain the above copyright
     notice, this list of conditions and the following disclaimer.
  2. Redistributions in binary form must reproduce the above copyright
     notice, this list of conditions and the following disclaimer in the
     documentation and/or other materials provided with the distribution.

  THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
  FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
  OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
  OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  SUCH DAMAGE.

  $Id: minicipa.pgoblin.m4,v 1.12 2019/07/26 00:28:39 babolo Exp $

#connect 0001
CIPA_DBMS
#perform 0001
CREATE TEMP TABLE a(i int, a text);
#getarg  1
#copyin  0011
COPY a FROM stdin;
#close   101
#perform 0001
CREATE TEMP TABLE e(i int, n text, e text);
#getenv  1
#copyin  0011
COPY e FROM stdin;
#close   101
#perform 0001
CREATE TEMP TABLE x(b text, u text);
#perform 0001
INSERT INTO x
 SELECT COALESCE( (SELECT a FROM a WHERE i = 0 AND regexp('^[a-z0-9_]+$', a))
                , 'minicipa'
                )
      , (SELECT e FROM e WHERE n = 'USER' AND regexp('^[a-z0-9_]+$', e))
;
#connect 000T
pgsql dbname=template1 requirepeer=postgres application_name=minicipa
#select  1001
SELECT 'CREATE ROLE ' || u || ' WITH LOGIN;' FROM x;
#select  G001
SELECT 'CREATE DATABASE ' || b || ';' FROM x;
#trap
#echo
Ignore it

#return
#perform 000T
CREATE ROLE www WITH LOGIN;
#perform 000T
CREATE ROLE operator WITH NOLOGIN;
#perform 010T
#perform 0G0T
#untrap
#select  1001
SELECT 'pgsql dbname=' || b || ' requirepeer=postgres application_name=minicipa'
 FROM x
;
#connect 0102
#close   101
#close   G0G
#select  1001
SELECT 'GRANT ALL ON DATABASE ' || b || ' TO www;' FROM x;
#perform 0102
#select  1001
SELECT 'GRANT CONNECT, TEMP ON DATABASE ' || b || ' TO operator;' FROM x;
#perform 0102
#perform 0002
CREATE EXTENSION IF NOT EXISTS babolo_pglib;
#perform 0002
CREATE EXTENSION IF NOT EXISTS pgcrypto;
#perform 0002
CREATE SEQUENCE IF NOT EXISTS public.gate_q MINVALUE 0;
#perform 0002
CREATE TABLE IF NOT EXISTS public.gate
     ( credent integer   PRIMARY KEY DEFAULT nextval('public.gate_q')
     , login   text      NOT NULL
     , src     cidr      NOT NULL
     , pass    text
     , entitle varbit
     )
;
#perform 0002
SELECT setval('public.gate_q', MAX(gate.credent)) FROM public.gate;
#perform 0002
CREATE UNIQUE INDEX IF NOT EXISTS gate_u ON public.gate(login, pass, src);
#perform 0002
CREATE SEQUENCE IF NOT EXISTS public.session_q MINVALUE 0;
#perform 0002
CREATE TABLE IF NOT EXISTS public.session
     ( session integer   PRIMARY KEY DEFAULT nextval('public.session_q')
     , credent integer   REFERENCES public.gate
     , csrc    inet      NOT NULL
     , creat   timestamp NOT NULL DEFAULT now()
     , updat   timestamp NOT NULL DEFAULT now()
     )
;
#perform 0002
SELECT setval('public.session_q', MAX(session.session)) FROM public.session;
#perform 0002
CREATE TABLE IF NOT EXISTS public.sessionb
     ( remov   timestamp NOT NULL DEFAULT now()
     ) INHERITS (public.session)
;
#perform 0002
CREATE TABLE IF NOT EXISTS public.cipaconf
     ( a1   int8
     , a2   int8
     , a3   int8
     , ln   interval
     , site text
     )
;
#perform 0002
CREATE OR REPLACE RULE sessionr AS
 ON DELETE TO public.session
 DO ALSO
  INSERT INTO public.sessionb(session, credent, csrc, creat, updat) SELECT OLD.*
;
#perform 0002
GRANT SELECT ON public.gate, public.session, public.session_q, public.sessionb, public.cipaconf
             TO www, operator
;
#perform 0002
GRANT REFERENCES ON public.gate, public.session TO www, operator;
#perform 0002
GRANT INSERT ON public.session TO www;
#perform 0002
GRANT UPDATE ON public.session, public.session_q TO www;
#perform 0002
GRANT DELETE ON public.session TO www;
#perform 0002
-- INSERT INTO cipaconf VALUES(18446744073709551615, 18446744073709501313, 14445763322349571339);
#perform 0002
INSERT INTO public.cipaconf
 SELECT 1073741825, 1073741101, 955835743, '30m'
  WHERE NOT EXISTS(SELECT 1 FROM public.cipaconf)
;
#perform 0002
CREATE OR REPLACE FUNCTION public.resess(sess int8)
 RETURNS int8
 AS 'SELECT ((sess * cipaconf.a3) + cipaconf.a2) % cipaconf.a1 FROM public.cipaconf'
 LANGUAGE SQL
 STABLE
 STRICT
 PARALLEL SAFE
;
#exit
#   ,     
#perform 0002
CREATE TABLE IF NOT EXISTS public.xlogge
     ( i int
     , n text
     , p text
     , l text
     , s text
     , a text
     , b text
     , t timestamp DEFAULT now()
     )
;
GRANT INSERT ON public.xlogge TO www;
